/*
 * Copyright (c) 2024 codvision.com All Rights Reserved.
 */

package com.codvision.basic.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.service.IService;
import com.codvision.basic.entity.Address;
import com.codvision.basic.entity.vo.AddressVO;
import com.codvision.basic.entity.vo.BatchAddressVO;
import com.codvision.webcore.bean.QueryPage;

import java.util.List;
import java.util.Map;

/**
 * @author KX
 */
public interface AddressService extends IService<Address> {

    /**
     * 分页列表
     * @param queryPage 查询条件
     * @return 列表
     */
    IPage<AddressVO> getPageResult(QueryPage<Map<String, Object>> queryPage);

    /**
     * 添加
     * @param address 地址信息
     */
    void add(Address address);

    /**
     * 更新
     * @param address 地址信息
     */
    void updateAddress(Address address);

    /**
     * 批量建楼幢
     * @param batchAddressVO 批量添加参数
     */
    void addList(BatchAddressVO batchAddressVO);

    /**
     * 详情
     * @param id 主键
     * @return 详情
     */
    AddressVO details(int id);

    /**
     * 根据楼幢编码查询房屋地址列表
     * @param queryPage 分页对象
     * @return 地址信息列表
     */
    IPage<AddressVO> getAddressHouseListByCode(QueryPage<Map<String, Object>> queryPage);

    /**
     * 获取楼幢下所有房屋列表
     * @param queryPage 分页对象
     * @return 地址信息列表
     */
    IPage<AddressVO> getAddressBuildingListByCode(QueryPage<Map<String, Object>> queryPage);

    /**
     * 批量逻辑删除
     * @param addressIds 地址id列表
     */
    void batchLogicDel(List<Integer> addressIds);
}
